unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CommHandle : hFile;
  DCB : TDCB;
  PortString: string;
  CommTimeOuts: TCOMMTIMEOUTS;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
PortString := '\\.\COM' + Edit1.Text;   
CommHandle := CreateFile(PChar(PortString), GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING,
         0, 0);

if (CommHandle = INVALID_HANDLE_VALUE) then
begin
  MessageDlg('Error. Can`t Open port', mtError, [mbOK], 0);
end
else
begin
  GetCommState(CommHandle, DCB);
  DCB.BaudRate  := CBR_9600; 
  DCB.Parity    := NOPARITY;
  DCB.ByteSize  := 8;
  DCB.StopBits  := OneStopBit;


  CommTimeOuts.ReadIntervalTimeout          := 0;
  CommTimeOuts.ReadTotalTimeoutMultiplier   := 0;
  CommTimeOuts.ReadTotalTimeoutConstant     := 1000;
  CommTimeOuts.WriteTotalTimeoutMultiplier  := 0;
  CommTimeOuts.WriteTotalTimeoutConstant    := 1000;
  SetCommTimeouts(CommHandle, CommTimeOuts);
  SetCommState(CommHandle, DCB);

  MessageDlg('Port Open Ok', mtInformation, [mbOK], 0);
end 
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  line:  Shortint;
  value: Shortint;
  valid: Boolean;
  buffer: string;
  CRbyte: Shortint;
  LFbyte: Shortint;
  NumberWritten : DWORD; 
begin
  line  := StrToInt(Edit2.Text);
  value := StrToInt(Edit3.Text);
  valid := TRUE;

if ((line > 24) or (line < 1)) then
begin
  MessageDlg('Invalid Line Number', mtError, [mbOK], 0);
  valid := FALSE;
end;

if ((value > 1) or (value < 0)) then
begin
  MessageDlg('Invalid Value', mtError, [mbOK], 0);
  valid := FALSE;
end;

if (valid = TRUE) then
begin
  CRbyte := 13; // HEX 0x0D
  LFbyte := 10; // HEX 0x0A
  buffer := '$KE,WR,' + Edit2.Text + ',' + Edit3.Text + Char(CRbyte) +
            Char(LFbyte);
  WriteFile(CommHandle, PChar(buffer)^, Length(buffer), NumberWritten, nil);
  
end;    
end;

end.
